// PipedThreads.java

import java.io.*;

class MyThread extends Thread
{
   private PipedReader pr;
   private PipedWriter pw;

   MyThread (String name, PipedReader pr, PipedWriter pw)
   {
      super (name);

      this.pr = pr;
      this.pw = pw;
   }

   public void run ()
   {
      try
      {
         if (getName ().equals ("src"))
         {
             for (int i = 0; i < 15; i++)
                  pw.write ("src " + " A" + i + "\n"); // src writes

             pw.close ();
         }
         else
         {
             int item;
             while ((item = pr.read ()) != -1)
                System.out.print ((char) item);        // dst reads

             pr.close ();
         }
      }
      catch (IOException e)
      {
      }
   }
}

class PipedThreads
{
   public static void main (String [] args) throws IOException
   {
      PipedWriter pw = new PipedWriter ();
      PipedReader pr = new PipedReader (pw);

      MyThread mt1 = new MyThread ("src", pr, pw);
      MyThread mt2 = new MyThread ("dst", pr, pw);

      mt1.start ();

      try
      {
         Thread.sleep (2000);
      }
      catch (InterruptedException e)
      {
      }

      mt2.start ();
   }
}
